% K-nearest neighbour classification with L1-distance metric and majority
% classification rule.
% Inputs: Xtrn - N x D training feature data
%         Xtst - M x D test feature data
%         Ytrn - N x 1 label vector
%            K - Number of nearest neighbours
% Output:   Yp - M x 1 predicted label vector for each test feature example
%
% (cc) Attribution-ShareAlike 3.0, Max Little, 2020. If you use this code,
% please cite M.A. Little, R. Badawy, "Causal Bootstrapping", 2019,
% arXiv:1910.09648

function Yp = knn(Xtrn,Xtst,Ytrn,K)
d = pdist2(Xtrn,Xtst,'L1');
[v,i] = sort(d,1);
i = i(1:K,:)';
Ypp = Ytrn(i);
Yp = mode(Ypp,2);
