% Use inverse transform sampling to draw N samples (returned in Nx1 vector
% x) from a categorical distribution with K-1 parameter vector p.
% 
% (cc) Attribution-ShareAlike 3.0, Max Little, 2020. If you use this code,
% please cite M.A. Little, R. Badawy, "Causal Bootstrapping", 2019,
% arXiv:1910.09648

function x = rand_cat_fast(p,N)
p = p(:);
K = length(p);
u = rand(N,1);
P = cumsum(p);
U = repmat(P',N,1);
c = repmat(u,1,K)>=U;
x = sum(c,2)+1;
